"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtendedNVMOperationsResponse = exports.ExtendedNVMOperationsWriteRequest = exports.ExtendedNVMOperationsReadRequest = exports.ExtendedNVMOperationsCloseRequest = exports.ExtendedNVMOperationsOpenRequest = exports.ExtendedNVMOperationsRequest = exports.ExtendedNVMOperationStatus = exports.ExtendedNVMOperationsCommand = void 0;
const core_1 = require("@zwave-js/core");
const serial_1 = require("@zwave-js/serial");
const shared_1 = require("@zwave-js/shared");
var ExtendedNVMOperationsCommand;
(function (ExtendedNVMOperationsCommand) {
    ExtendedNVMOperationsCommand[ExtendedNVMOperationsCommand["Open"] = 0] = "Open";
    ExtendedNVMOperationsCommand[ExtendedNVMOperationsCommand["Read"] = 1] = "Read";
    ExtendedNVMOperationsCommand[ExtendedNVMOperationsCommand["Write"] = 2] = "Write";
    ExtendedNVMOperationsCommand[ExtendedNVMOperationsCommand["Close"] = 3] = "Close";
})(ExtendedNVMOperationsCommand || (exports.ExtendedNVMOperationsCommand = ExtendedNVMOperationsCommand = {}));
var ExtendedNVMOperationStatus;
(function (ExtendedNVMOperationStatus) {
    ExtendedNVMOperationStatus[ExtendedNVMOperationStatus["OK"] = 0] = "OK";
    ExtendedNVMOperationStatus[ExtendedNVMOperationStatus["Error"] = 1] = "Error";
    ExtendedNVMOperationStatus[ExtendedNVMOperationStatus["Error_OperationMismatch"] = 2] = "Error_OperationMismatch";
    ExtendedNVMOperationStatus[ExtendedNVMOperationStatus["Error_OperationInterference"] = 3] = "Error_OperationInterference";
    ExtendedNVMOperationStatus[ExtendedNVMOperationStatus["Error_SubCommandNotSupported"] = 4] = "Error_SubCommandNotSupported";
    ExtendedNVMOperationStatus[ExtendedNVMOperationStatus["EndOfFile"] = 255] = "EndOfFile";
})(ExtendedNVMOperationStatus || (exports.ExtendedNVMOperationStatus = ExtendedNVMOperationStatus = {}));
let ExtendedNVMOperationsRequest = class ExtendedNVMOperationsRequest extends serial_1.Message {
    // This must be set in subclasses
    command;
    serialize() {
        this.payload = Buffer.concat([
            Buffer.from([this.command]),
            this.payload,
        ]);
        return super.serialize();
    }
    toLogEntry() {
        const message = {
            command: (0, shared_1.getEnumMemberName)(ExtendedNVMOperationsCommand, this.command),
        };
        return {
            ...super.toLogEntry(),
            message,
        };
    }
};
exports.ExtendedNVMOperationsRequest = ExtendedNVMOperationsRequest;
exports.ExtendedNVMOperationsRequest = ExtendedNVMOperationsRequest = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Request, serial_1.FunctionType.ExtendedNVMOperations),
    (0, serial_1.priority)(core_1.MessagePriority.Controller),
    (0, serial_1.expectedResponse)(serial_1.FunctionType.ExtendedNVMOperations)
], ExtendedNVMOperationsRequest);
// =============================================================================
class ExtendedNVMOperationsOpenRequest extends ExtendedNVMOperationsRequest {
    constructor(host, options) {
        super(host, options);
        this.command = ExtendedNVMOperationsCommand.Open;
    }
}
exports.ExtendedNVMOperationsOpenRequest = ExtendedNVMOperationsOpenRequest;
// =============================================================================
class ExtendedNVMOperationsCloseRequest extends ExtendedNVMOperationsRequest {
    constructor(host, options) {
        super(host, options);
        this.command = ExtendedNVMOperationsCommand.Close;
    }
}
exports.ExtendedNVMOperationsCloseRequest = ExtendedNVMOperationsCloseRequest;
class ExtendedNVMOperationsReadRequest extends ExtendedNVMOperationsRequest {
    constructor(host, options) {
        super(host, options);
        this.command = ExtendedNVMOperationsCommand.Read;
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            throw new core_1.ZWaveError(`${this.constructor.name}: deserialization not implemented`, core_1.ZWaveErrorCodes.Deserialization_NotImplemented);
        }
        else {
            if (options.length < 0 || options.length > 0xff) {
                throw new core_1.ZWaveError("The length must be between 0 and 255!", core_1.ZWaveErrorCodes.Argument_Invalid);
            }
            if (options.offset < 0 || options.offset > 0xffffffff) {
                throw new core_1.ZWaveError("The offset must be a 32-bit number!", core_1.ZWaveErrorCodes.Argument_Invalid);
            }
            this.length = options.length;
            this.offset = options.offset;
        }
    }
    length;
    offset;
    serialize() {
        this.payload = Buffer.allocUnsafe(5);
        this.payload[0] = this.length;
        this.payload.writeUInt32BE(this.offset, 1);
        return super.serialize();
    }
    toLogEntry() {
        const ret = super.toLogEntry();
        return {
            ...ret,
            message: {
                ...ret.message,
                "data length": this.length,
                "address offset": (0, shared_1.num2hex)(this.offset),
            },
        };
    }
}
exports.ExtendedNVMOperationsReadRequest = ExtendedNVMOperationsReadRequest;
class ExtendedNVMOperationsWriteRequest extends ExtendedNVMOperationsRequest {
    constructor(host, options) {
        super(host, options);
        this.command = ExtendedNVMOperationsCommand.Write;
        if ((0, serial_1.gotDeserializationOptions)(options)) {
            throw new core_1.ZWaveError(`${this.constructor.name}: deserialization not implemented`, core_1.ZWaveErrorCodes.Deserialization_NotImplemented);
        }
        else {
            if (options.offset < 0 || options.offset > 0xffffffff) {
                throw new core_1.ZWaveError("The offset must be a 32-bit number!", core_1.ZWaveErrorCodes.Argument_Invalid);
            }
            if (options.buffer.length < 1 || options.buffer.length > 0xff) {
                throw new core_1.ZWaveError("The buffer must be between 1 and 255 bytes long", core_1.ZWaveErrorCodes.Argument_Invalid);
            }
            this.offset = options.offset;
            this.buffer = options.buffer;
        }
    }
    offset;
    buffer;
    serialize() {
        this.payload = Buffer.allocUnsafe(1 + 4 + this.buffer.length);
        this.payload[0] = this.buffer.length;
        this.payload.writeUInt32BE(this.offset, 1);
        this.buffer.copy(this.payload, 5);
        return super.serialize();
    }
    toLogEntry() {
        const ret = super.toLogEntry();
        return {
            ...ret,
            message: {
                ...ret.message,
                offset: (0, shared_1.num2hex)(this.offset),
                buffer: `(${this.buffer.length} byte${this.buffer.length === 1 ? "" : "s"})`,
            },
        };
    }
}
exports.ExtendedNVMOperationsWriteRequest = ExtendedNVMOperationsWriteRequest;
// =============================================================================
let ExtendedNVMOperationsResponse = class ExtendedNVMOperationsResponse extends serial_1.Message {
    constructor(host, options) {
        super(host, options);
        (0, core_1.validatePayload)(this.payload.length >= 2);
        this.status = this.payload[0];
        const dataLength = this.payload[1];
        let offset = 2;
        if (this.payload.length >= offset + 4) {
            this.offsetOrSize = this.payload.readUInt32BE(offset);
        }
        else {
            this.offsetOrSize = 0;
        }
        offset += 4;
        // The buffer will contain:
        // - Read command: the read NVM data
        // - Write/Close command: nothing
        // - Open command: bit mask of supported sub-commands
        if (dataLength > 0 && this.payload.length >= offset + dataLength) {
            this.bufferOrBitmask = this.payload.subarray(offset, offset + dataLength);
        }
        else {
            this.bufferOrBitmask = Buffer.from([]);
        }
    }
    isOK() {
        return (this.status === ExtendedNVMOperationStatus.OK
            || this.status === ExtendedNVMOperationStatus.EndOfFile);
    }
    status;
    offsetOrSize;
    bufferOrBitmask;
    toLogEntry() {
        const message = {
            status: (0, shared_1.getEnumMemberName)(ExtendedNVMOperationStatus, this.status),
            "address offset / NVM size": (0, shared_1.num2hex)(this.offsetOrSize),
        };
        if (this.bufferOrBitmask.length > 0) {
            message.buffer = `(${this.bufferOrBitmask.length} byte${this.bufferOrBitmask.length === 1 ? "" : "s"})`;
        }
        return {
            ...super.toLogEntry(),
            message,
        };
    }
};
exports.ExtendedNVMOperationsResponse = ExtendedNVMOperationsResponse;
exports.ExtendedNVMOperationsResponse = ExtendedNVMOperationsResponse = __decorate([
    (0, serial_1.messageTypes)(serial_1.MessageType.Response, serial_1.FunctionType.ExtendedNVMOperations)
], ExtendedNVMOperationsResponse);
//# sourceMappingURL=ExtendedNVMOperationsMessages.js.map